1. Removed two additional widgets from the rebinding list: push-input and push-line-or-edit. Both didn't call "_zsh_highlight" function anyhow due to operation principle of these widgets.

2. Adjusted place where zle_highlight is added to region_highlight in order to do it only once (not for all highlithers).

3. Changed indentation in zsh-syntax-highlighting.zsh to make code a bit cleaner and easier to read.
This commit is contained in:
jimmijj 2015-09-04 02:36:22 +02:00
parent ece762e817
commit 3a6ba003d1

View File

@ -42,63 +42,65 @@ typeset -ga ZSH_HIGHLIGHT_HIGHLIGHTERS
# This function is supposed to be called whenever the ZLE state changes. # This function is supposed to be called whenever the ZLE state changes.
_zsh_highlight() _zsh_highlight()
{ {
setopt localoptions nowarncreateglobal setopt localoptions nowarncreateglobal
# Store the previous command return code to restore it whatever happens. # Store the previous command return code to restore it whatever happens.
local ret=$? local ret=$?
# Do not highlight if there are more than 300 chars in the buffer. It's most # Do not highlight if there are more than 300 chars in the buffer. It's most
# likely a pasted command or a huge list of files in that case.. # likely a pasted command or a huge list of files in that case..
[[ -n ${ZSH_HIGHLIGHT_MAXLENGTH:-} ]] && [[ $#BUFFER -gt $ZSH_HIGHLIGHT_MAXLENGTH ]] && return $ret [[ -n ${ZSH_HIGHLIGHT_MAXLENGTH:-} ]] && [[ $#BUFFER -gt $ZSH_HIGHLIGHT_MAXLENGTH ]] && return $ret
# Do not highlight if there are pending inputs (copy/paste). # Do not highlight if there are pending inputs (copy/paste).
[[ $PENDING -gt 0 ]] && return $ret [[ $PENDING -gt 0 ]] && return $ret
# Reset region highlight to build it from scratch # Reset region highlight to build it from scratch
region_highlight=(); region_highlight=();
{ {
local cache_place local cache_place
local -a region_highlight_copy local -a region_highlight_copy
# Select which highlighters in ZSH_HIGHLIGHT_HIGHLIGHTERS need to be invoked. # Select which highlighters in ZSH_HIGHLIGHT_HIGHLIGHTERS need to be invoked.
local highlighter; for highlighter in $ZSH_HIGHLIGHT_HIGHLIGHTERS; do local highlighter
for highlighter in $ZSH_HIGHLIGHT_HIGHLIGHTERS; do
# eval cache place for current highlighter and prepare it # eval cache place for current highlighter and prepare it
cache_place="_zsh_highlight_${highlighter}_highlighter_cache" cache_place="_zsh_highlight_${highlighter}_highlighter_cache"
typeset -ga ${cache_place} typeset -ga ${cache_place}
# If highlighter needs to be invoked # If highlighter needs to be invoked
if "_zsh_highlight_${highlighter}_highlighter_predicate"; then if "_zsh_highlight_${highlighter}_highlighter_predicate"; then
# save a copy, and cleanup region_highlight # save a copy, and cleanup region_highlight
region_highlight_copy=("${region_highlight[@]}") region_highlight_copy=("${region_highlight[@]}")
region_highlight=() region_highlight=()
# Execute highlighter and save result # Execute highlighter and save result
{ {
"_zsh_highlight_${highlighter}_highlighter" "_zsh_highlight_${highlighter}_highlighter"
} always { } always {
eval "${cache_place}=(\"\${region_highlight[@]}\")" eval "${cache_place}=(\"\${region_highlight[@]}\")"
} }
# Restore saved region_highlight # Restore saved region_highlight
region_highlight=("${region_highlight_copy[@]}") region_highlight=("${region_highlight_copy[@]}")
fi fi
# Use value form cache if any cached # Use value form cache if any cached
eval "region_highlight+=(\"\${${cache_place}[@]}\")" eval "region_highlight+=(\"\${${cache_place}[@]}\")"
# Bring back region higlighting from zle_highlight array (was overwriten by region_highlight) done
((REGION_ACTIVE)) && region_highlight+=("$((CURSOR < MARK ? CURSOR : MARK)) $((CURSOR > MARK ? CURSOR : MARK)) ${${(M)zle_highlight[@]:#region*}#region:}")
done
} always { # Bring back region higlighting from zle_highlight array (was overwriten by region_highlight)
_ZSH_HIGHLIGHT_PRIOR_BUFFER=$BUFFER ((REGION_ACTIVE)) && region_highlight+=("$((CURSOR < MARK ? CURSOR : MARK)) $((CURSOR > MARK ? CURSOR : MARK)) ${${(M)zle_highlight[@]:#region*}#region:}")
_ZSH_HIGHLIGHT_PRIOR_CURSOR=$CURSOR
return $ret } always {
} _ZSH_HIGHLIGHT_PRIOR_BUFFER=$BUFFER
_ZSH_HIGHLIGHT_PRIOR_CURSOR=$CURSOR
return $ret
}
} }
@ -115,7 +117,7 @@ typeset -gA ZSH_HIGHLIGHT_FILES
# Returns 0 if the buffer has changed since _zsh_highlight was last called. # Returns 0 if the buffer has changed since _zsh_highlight was last called.
_zsh_highlight_buffer_modified() _zsh_highlight_buffer_modified()
{ {
[[ "${_ZSH_HIGHLIGHT_PRIOR_BUFFER:-}" != "$BUFFER" ]] [[ "${_ZSH_HIGHLIGHT_PRIOR_BUFFER:-}" != "$BUFFER" ]]
} }
# Whether the cursor has moved or not. # Whether the cursor has moved or not.
@ -123,7 +125,7 @@ _zsh_highlight_buffer_modified()
# Returns 0 if the cursor has moved since _zsh_highlight was last called. # Returns 0 if the cursor has moved since _zsh_highlight was last called.
_zsh_highlight_cursor_moved() _zsh_highlight_cursor_moved()
{ {
[[ -n $CURSOR ]] && [[ -n ${_ZSH_HIGHLIGHT_PRIOR_CURSOR-} ]] && (($_ZSH_HIGHLIGHT_PRIOR_CURSOR != $CURSOR)) [[ -n $CURSOR ]] && [[ -n ${_ZSH_HIGHLIGHT_PRIOR_CURSOR-} ]] && (($_ZSH_HIGHLIGHT_PRIOR_CURSOR != $CURSOR))
} }
@ -134,38 +136,38 @@ _zsh_highlight_cursor_moved()
# Rebind all ZLE widgets to make them invoke _zsh_highlights. # Rebind all ZLE widgets to make them invoke _zsh_highlights.
_zsh_highlight_bind_widgets() _zsh_highlight_bind_widgets()
{ {
# Load ZSH module zsh/zleparameter, needed to override user defined widgets. # Load ZSH module zsh/zleparameter, needed to override user defined widgets.
zmodload zsh/zleparameter 2>/dev/null || { zmodload zsh/zleparameter 2>/dev/null || {
echo 'zsh-syntax-highlighting: failed loading zsh/zleparameter.' >&2 echo 'zsh-syntax-highlighting: failed loading zsh/zleparameter.' >&2
return 1 return 1
} }
# Override ZLE widgets to make them invoke _zsh_highlight. # Override ZLE widgets to make them invoke _zsh_highlight.
local cur_widget local cur_widget
for cur_widget in ${${(f)"$(builtin zle -la)"}:#(.*|_*|orig-*|run-help|beep|auto-*|*-argument|argument-base|clear-screen|describe-key-briefly|kill-buffer|overwrite-mode|reset-prompt|set-local-history|split-undo|undefined-key|what-cursor-position|where-is)}; do for cur_widget in ${${(f)"$(builtin zle -la)"}:#(.*|_*|orig-*|run-help|beep|auto-*|*-argument|argument-base|clear-screen|describe-key-briefly|kill-buffer|overwrite-mode|push-input|push-line-or-edit|reset-prompt|set-local-history|split-undo|undefined-key|what-cursor-position|where-is)}; do
case $widgets[$cur_widget] in case $widgets[$cur_widget] in
# Already rebound event: do nothing. # Already rebound event: do nothing.
user:$cur_widget|user:_zsh_highlight_widget_*);; user:$cur_widget|user:_zsh_highlight_widget_*);;
# User defined widget: override and rebind old one with prefix "orig-". # User defined widget: override and rebind old one with prefix "orig-".
user:*) eval "zle -N orig-$cur_widget ${widgets[$cur_widget]#*:}; \ user:*) eval "zle -N orig-$cur_widget ${widgets[$cur_widget]#*:}; \
_zsh_highlight_widget_$cur_widget() { builtin zle orig-$cur_widget -- \"\$@\" && _zsh_highlight }; \ _zsh_highlight_widget_$cur_widget() { builtin zle orig-$cur_widget -- \"\$@\" && _zsh_highlight }; \
zle -N $cur_widget _zsh_highlight_widget_$cur_widget";; zle -N $cur_widget _zsh_highlight_widget_$cur_widget";;
# Completion widget: override and rebind old one with prefix "orig-". # Completion widget: override and rebind old one with prefix "orig-".
completion:*) eval "zle -C orig-$cur_widget ${${widgets[$cur_widget]#*:}/:/ }; \ completion:*) eval "zle -C orig-$cur_widget ${${widgets[$cur_widget]#*:}/:/ }; \
_zsh_highlight_widget_$cur_widget() { builtin zle orig-$cur_widget -- \"\$@\" && _zsh_highlight }; \ _zsh_highlight_widget_$cur_widget() { builtin zle orig-$cur_widget -- \"\$@\" && _zsh_highlight }; \
zle -N $cur_widget _zsh_highlight_widget_$cur_widget";; zle -N $cur_widget _zsh_highlight_widget_$cur_widget";;
# Builtin widget: override and make it call the builtin ".widget". # Builtin widget: override and make it call the builtin ".widget".
builtin) eval "_zsh_highlight_widget_$cur_widget() { builtin zle .$cur_widget -- \"\$@\" && _zsh_highlight }; \ builtin) eval "_zsh_highlight_widget_$cur_widget() { builtin zle .$cur_widget -- \"\$@\" && _zsh_highlight }; \
zle -N $cur_widget _zsh_highlight_widget_$cur_widget";; zle -N $cur_widget _zsh_highlight_widget_$cur_widget";;
# Default: unhandled case. # Default: unhandled case.
*) echo "zsh-syntax-highlighting: unhandled ZLE widget '$cur_widget'" >&2 ;; *) echo "zsh-syntax-highlighting: unhandled ZLE widget '$cur_widget'" >&2 ;;
esac esac
done done
} }
# Load highlighters from directory. # Load highlighters from directory.
@ -174,24 +176,24 @@ _zsh_highlight_bind_widgets()
# 1) Path to the highlighters directory. # 1) Path to the highlighters directory.
_zsh_highlight_load_highlighters() _zsh_highlight_load_highlighters()
{ {
# Check the directory exists. # Check the directory exists.
[[ -d "$1" ]] || { [[ -d "$1" ]] || {
echo "zsh-syntax-highlighting: highlighters directory '$1' not found." >&2 echo "zsh-syntax-highlighting: highlighters directory '$1' not found." >&2
return 1 return 1
}
# Load highlighters from highlighters directory and check they define required functions.
local highlighter highlighter_dir
for highlighter_dir ($1/*/); do
highlighter="${highlighter_dir:t}"
[[ -f "$highlighter_dir/${highlighter}-highlighter.zsh" ]] && {
. "$highlighter_dir/${highlighter}-highlighter.zsh"
type "_zsh_highlight_${highlighter}_highlighter" &> /dev/null &&
type "_zsh_highlight_${highlighter}_highlighter_predicate" &> /dev/null || {
echo "zsh-syntax-highlighting: '${highlighter}' highlighter should define both required functions '_zsh_highlight_${highlighter}_highlighter' and '_zsh_highlight_${highlighter}_highlighter_predicate' in '${highlighter_dir}/${highlighter}-highlighter.zsh'." >&2
}
} }
done
# Load highlighters from highlighters directory and check they define required functions.
local highlighter highlighter_dir
for highlighter_dir ($1/*/); do
highlighter="${highlighter_dir:t}"
[[ -f "$highlighter_dir/${highlighter}-highlighter.zsh" ]] && {
. "$highlighter_dir/${highlighter}-highlighter.zsh"
type "_zsh_highlight_${highlighter}_highlighter" &> /dev/null &&
type "_zsh_highlight_${highlighter}_highlighter_predicate" &> /dev/null || {
echo "zsh-syntax-highlighting: '${highlighter}' highlighter should define both required functions '_zsh_highlight_${highlighter}_highlighter' and '_zsh_highlight_${highlighter}_highlighter_predicate' in '${highlighter_dir}/${highlighter}-highlighter.zsh'." >&2
}
}
done
} }
@ -201,26 +203,26 @@ _zsh_highlight_load_highlighters()
# Try binding widgets. # Try binding widgets.
_zsh_highlight_bind_widgets || { _zsh_highlight_bind_widgets || {
echo 'zsh-syntax-highlighting: failed binding ZLE widgets, exiting.' >&2 echo 'zsh-syntax-highlighting: failed binding ZLE widgets, exiting.' >&2
return 1 return 1
} }
# Resolve highlighters directory location. # Resolve highlighters directory location.
_zsh_highlight_load_highlighters "${ZSH_HIGHLIGHT_HIGHLIGHTERS_DIR:-${${0:A}:h}/highlighters}" || { _zsh_highlight_load_highlighters "${ZSH_HIGHLIGHT_HIGHLIGHTERS_DIR:-${${0:A}:h}/highlighters}" || {
echo 'zsh-syntax-highlighting: failed loading highlighters, exiting.' >&2 echo 'zsh-syntax-highlighting: failed loading highlighters, exiting.' >&2
return 1 return 1
} }
# Reset scratch variables when commandline is done. # Reset scratch variables when commandline is done.
_zsh_highlight_preexec_hook() _zsh_highlight_preexec_hook()
{ {
_ZSH_HIGHLIGHT_PRIOR_BUFFER= _ZSH_HIGHLIGHT_PRIOR_BUFFER=
_ZSH_HIGHLIGHT_PRIOR_CURSOR= _ZSH_HIGHLIGHT_PRIOR_CURSOR=
} }
autoload -U add-zsh-hook autoload -U add-zsh-hook
add-zsh-hook preexec _zsh_highlight_preexec_hook 2>/dev/null || { add-zsh-hook preexec _zsh_highlight_preexec_hook 2>/dev/null || {
echo 'zsh-syntax-highlighting: failed loading add-zsh-hook.' >&2 echo 'zsh-syntax-highlighting: failed loading add-zsh-hook.' >&2
} }
# Initialize the array of active highlighters if needed. # Initialize the array of active highlighters if needed.
[[ $#ZSH_HIGHLIGHT_HIGHLIGHTERS -eq 0 ]] && ZSH_HIGHLIGHT_HIGHLIGHTERS=(main) || true [[ $#ZSH_HIGHLIGHT_HIGHLIGHTERS -eq 0 ]] && ZSH_HIGHLIGHT_HIGHLIGHTERS=(main) || true